import 'tinymce';
export declare const GUID: {
    createNew: () => string;
};
export declare const SHA1: {
    generateUniqueID: (inputString: any) => string;
    generateFromString: (msg: any) => any;
};
export declare const Util: {
    util: {
        uid: () => string;
    };
    normalize: (name: any) => string;
    getFilenameFromURL: (url: any) => any;
    getPlainTextForHtmlPanel: (content: any) => any;
    getHtmlBody: (source: any) => any;
    getHtmlEncoded: (value: any) => string;
    getHtmlDecoded: (value: any, escape: any) => string;
    text2html: (source: any) => string;
    html2plaintext: (source: any) => string;
    fastHtml2text: (source: any) => string;
    html2text: (source: any, htmlLight: any) => any;
    parseUrl: (url: any) => any;
    getUrlParser: (path: any) => HTMLAnchorElement;
    getSafeHash: (value: any) => string;
    /**
     * Escapes html-relevant characters like &, <, >, quotes.
     */
    escapeHtml: (string: any) => string;
    getUniqueFileName: (fileName: any, existingNamesArray: any) => any;
    getUniqueName: (array: any, element: any, fieldName: any) => any;
    arrayToString: (array: any, suffix: any, prefix: any) => string;
    scrollToCenterOfElement: (selector: any, scrollContainerSelector: any, backupScrollPosition: any) => void;
    areEqual: (x: any, y: any) => boolean;
    inArray: (object: any, array: any) => boolean;
};
/**
 * encrypt a json to save transfer to the server
 * @param json the json to encrypt
 * @returns {string} the encrypted json
 */
export declare function encrypt(json: any): string;
/**
 * Returns the json object for the given received data. It will be decrypted and converted if the data is a string. For IE8, the stream is not encrypted, so the object is the resulting instance.
 * @param data the received data from POST request. Needs to be deserialized if it is type of "string"
 * @returns the deserialized json object
 */
export declare function extractJson(data: any): any;
export declare function extractJsonBytes(data: any): any;
export declare function arrayBufferToBase64(buffer: any): string;
export declare function base64ToArrayBuffer(base64: any): ArrayBufferLike;
export declare function arrayToArrayBuffer(array: any): ArrayBufferLike;
export declare function arrayToArrayBufferView(array: any): Uint8Array;
export declare function toUTF8Array(str: any): any[];
export declare const utf8ArrayToStr: (array: any) => string;
/**
 * decrypt a json from the server
 * @param qwirks the string to decrypt
 * @returns {string} the decrypted json
 */
export declare function decrypt(qwirks: any): any;
export declare const ColorUtil: {
    HSVtoRGB: (h: any, s: any, v: any) => {
        r: number;
        g: number;
        b: number;
    };
    componentToHex: (c: any) => any;
    rgbToHex: (r: any, g: any, b: any) => string;
    parseRGB: (rgb: any) => string;
    hexToRgba: (hex: any, alpha: any) => string;
    mix: (color_1: any, color_2: any, weight: any) => string;
    getPriorityColor: (priorityIndex: any, priorityCount: any) => string;
    getColorForID: (id: any) => {
        r: number;
        g: number;
        b: number;
    };
};
export declare const FieldUtil: {
    getDisplayValue: (ticketModel: any, data: any, field: any) => any;
    getDataID: (field: any) => 0 | 6 | 12 | 10 | 1 | -1 | 2 | 4 | 7 | 3 | 5 | 9 | 11;
    convertAttachmentDescription: (att: any) => {
        name: any;
        lastModified: string;
        lastModifiedValue: any;
        attachmentType: string;
        size: string;
        sizeValue: any;
        id: string;
        idValue: any;
        mimetype: string;
        serverpath: any;
        stepId: any;
        type: any;
    };
    isImageFile: (filename: any) => boolean;
    isImageFileType: (type: any) => boolean;
    isTxtFile: (filename: any) => boolean;
    removeObsoleteEmbeddedImages: (htmlTextArray: any, attachments: any) => any;
};
export declare const JsonUtil: {
    checkForDifferences: (data: any, refData: any) => boolean;
    createSnapshot: (data: any) => any;
};
export declare const FormFieldUtil: {
    checkForDifferences: (model: any, initialData: any) => {};
    createSnapshot: (model: any) => any[];
    checkForHDDifferences: (model: any, initialData: any) => any[];
    createHDSnapshot: (model: any) => any[];
    getStringRepresentation: (value: any, asJson: any) => string;
    createArrayString: (value: any) => string;
    createObjectString: (value: any) => string;
};
export declare const ValueFormatter: {
    formatFileSize: (size: any) => string;
    formatTime: (time: number) => string;
    momentInitialized: boolean;
    initializeMomentJs: () => void;
    formatDate: (date: any, fullDetails: any) => string;
};
export declare const ArrayHelper: {
    jsonDataToMap: (input: any, key_key: any, value_key: any) => {};
    toMap: (input: any, key_key: any, value_key: any) => {};
    toStringValueMap: (input: any, key_key: any, value_key: any) => {};
};
/**
*
*  Base64 encode / decode
*  http://www.webtoolkit.info/
*
**/
export declare const Base64Decoder: {
    _keyStr: string;
    encode: (input: any) => string;
    decode: (input: any) => string;
    _utf8_encode: (string: any) => string;
    _utf8_decode: (utftext: any) => string;
};
/**
*
*  NumberUtil for IE constants
*
**/
export declare const NumberUtil: {
    MAX_SAFE_INTEGER: () => number;
    parseLocaleNumber: (locale: any, nmbr: any) => number;
};
